//	yf Net list readers 1
//		2005.10.11 - 2005.10.16 Yoshaiki.Ueda
#include "wx/wx.h"
#include "yfNetListReaders1.h"

//	BSch Reader	//=============================================================
IMPLEMENT_DYNAMIC_CLASS(yfNetBschReader, yfNetListReader)

yfNetBschReader::yfNetBschReader()
	: m_inList(false)
{
	m_tokenizer.SetKeywords(wxT(";,"));
}

void yfNetBschReader::OnToken(const wxString& token)
{
	if( token==wxT("$NETS") ){
		//begin net
		m_inList = true;
	}else
	if( token==wxT("$END") ){
		m_inList = false;
	}else
	if( m_inList ){
		if( token==wxT(";") ){
			BeginOfNet(m_lastToken);
		}else
		if( token==wxT(",") ){
		}else{
			OnNode(token);
		}
	}
}

void yfNetBschReader::OnTermLine()
{
	if( m_inList && m_lastToken!=wxT(",") ){
		EndOfNet();
	}
}

/*
void yfNetBschReader::Init()
{
	m_stateSection = SEC_END;
}

void yfNetBschReader::ParseLine(const wxString& source)
{
	wxStringTokenizer tkz(source);
	wxString token = tkz.GetNextToken();
	//Section
	if(token==wxT("$PACKAGES")){
		m_stateSection = SEC_PACKAGES;
	}else
	if(token==wxT("$NETS")){
		m_stateSection = SEC_NETS;
	}else
	if(token==wxT("$END")){
		m_stateSection = SEC_END;
		//end of net
		EndOfNet();
	}else
	if(m_stateSection==SEC_NETS){	//in nets
		if(token.Last()==wxT(';')){
			token.RemoveLast();
			//end of net
			EndOfNet();
			//begin of net
			BeginOfNet(token);
			//m_currentNet = new yfNetList::Net;
			//m_currentNet->m_beginLine = m_currentLine;
			//m_currentNet->m_name = token;
			token = tkz.GetNextToken();
		}
		while(!token.IsEmpty()){
			if( token==wxT(",") ){
			}else
			if( m_currentNet && !token.IsEmpty() ){	//in one net
				//Node
				yfNetList::Net::Node* node = new yfNetList::Net::Node;
				node->m_name = token;
				m_currentNet->m_nodeList.push_back(*node);
			}
			token = tkz.GetNextToken();
		}
	}
}
*/

//	PADS Reader	//=============================================================
IMPLEMENT_DYNAMIC_CLASS(yfNetPadsReader, yfNetListReader)

void yfNetPadsReader::ParseLine(const wxString& source)
{
	wxStringTokenizer tkz(source);
	wxString token = tkz.GetNextToken();
	if(token[0]=='*'){
		//end of net
		EndOfNet();
		if( token==wxT("*SIG") || token==wxT("*SIGNAL*") ){
			//begin of net
			BeginOfNet(tkz.GetNextToken());
		}
	}else if(m_currentNet){
		//in net
		while(!token.IsEmpty()){
			//Node
			OnNode(token);
			token = tkz.GetNextToken();
		}
	}
}

//	ECF Reader	//=============================================================
IMPLEMENT_DYNAMIC_CLASS(yfNetECFReader, yfNetListReader)

yfNetECFReader::yfNetECFReader()
	: m_inList(false)
{
	m_tokenizer.SetKeywords(wxT("{}:;,"));
}

void yfNetECFReader::OnToken(const wxString& token)
{
	if( token==wxT("{") ){
		if( m_lastToken==wxT("NET") ||
				m_lastToken==wxT("POWER") || m_lastToken==wxT("GROUND") ){
			//begin net
			m_inList = true;
		}
	}else
	if( token==wxT("}") ){
		m_inList = false;
	}else
	if( m_inList ){
		if( token==wxT(":") ){
			BeginOfNet(m_lastToken);
		}else
		if( token==wxT(";") ){
			EndOfNet();
		}else
		if( token==wxT(",") ){
		}else{
			wxString node = token;
			node.Replace(wxT("("),wxT("."));
			node.Replace(wxT(")"),wxT(" "));
			node.Trim();
			OnNode(node);
		}
	}
}


//	BSch Reader	//=============================================================
IMPLEMENT_DYNAMIC_CLASS(yfNetProtelReader, yfNetListReader)

yfNetProtelReader::yfNetProtelReader()
{
	m_tokenizer.SetKeywords(wxT("()[]"));
	startnet = false;
	innet = false;
	incomponent = false;
}

void yfNetProtelReader::OnToken(const wxString& token)
{
	if( token==wxT("[") ){
		incomponent = true;
	}
	else if(incomponent && token==wxT("]") ){
		startnet = false;
		innet = false;
		incomponent = false;
	}

	if(!incomponent){
		if( token==wxT("(") ){
			//begin net
			startnet = true;
			innet = true;
		}else
		if( token==wxT(")") ){
			startnet = false;	//for void net.
			innet = false;
		}else
		if( innet ){
			if( startnet ){
				BeginOfNet(token);
				startnet = false;
			}else{
				wxString node = token;
				node.Replace(wxT("-"),wxT("."));
				OnNode(node);
			}
		}
	}
}
